﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace XDGDragFromTreeViewCase
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }
        public List<string> Names { get; set; }

        string[] names = "Andrew;Alex;Jen;Steve;Eric;Tom;Jessica;Valerie;Devin;Pamela;Mike".Split(';');

        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for (int i = 0; i < names.Length; i++)
            {
                Names = names.ToList();
                Data.Add(new SampleData()
                {
                    ID = i,
                    Name = string.Empty
                });                
            }
        }
    }

    public class SampleData : ObservableModel
    {
        private int _id;
        public int ID
        {
            get { return _id; }
            set
            {
                if(_id != value)
                {
                    _id = value;
                    OnPropertyChanged();
                }
            }
        }
                    

        private string _name;
        public string Name
        {
            get { return _name; }
            set
            {
                if(_name != value)
                {
                    _name = value;
                    OnPropertyChanged();
                }
            }
        }       
    }

    public class ObservableModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged([CallerMemberName] String propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

    }
}
